diff -crBPN --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=wordpress.sql --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.4.pl ./wordpress-3.3.2/wp-admin/custom-header.php ./wordpress-3.4/wp-admin/custom-header.php
*** ./wordpress-3.3.2/wp-admin/custom-header.php	2011-11-30 20:28:47.000000000 -0600
--- ./wordpress-3.4/wp-admin/custom-header.php	2012-06-09 19:32:19.000000000 -0500
***************
*** 72,77 ****
--- 71,78 ----
  	function __construct($admin_header_callback, $admin_image_div_callback = '') {
  		$this->admin_header_callback = $admin_header_callback;
  		$this->admin_image_div_callback = $admin_image_div_callback;
+ 
+ 		add_action( 'admin_menu', array( $this, 'init' ) );
  	}
  
  	/**
***************
*** 90,96 ****
  		add_action("admin_head-$page", array(&$this, 'help') );
  		add_action("admin_head-$page", array(&$this, 'take_action'), 50);
  		add_action("admin_head-$page", array(&$this, 'js'), 50);
! 		add_action("admin_head-$page", $this->admin_header_callback, 51);
  	}
  
  	/**
--- 91,104 ----
  		add_action("admin_head-$page", array(&$this, 'help') );
  		add_action("admin_head-$page", array(&$this, 'take_action'), 50);
  		add_action("admin_head-$page", array(&$this, 'js'), 50);
! 		if ( $this->admin_header_callback )
! 			add_action("admin_head-$page", $this->admin_header_callback, 51);
! 
! 		if ( isset( $_REQUEST['context'] ) && $_REQUEST['context'] == 'custom-header' ) {
! 			add_filter( 'attachment_fields_to_edit', array( $this, 'attachment_fields_to_edit' ), 10, 2 );
! 			add_filter( 'media_upload_tabs', array( $this, 'filter_upload_tabs' ) );
! 			add_filter( 'media_upload_mime_type_links', '__return_empty_array' );
! 		}
  	}
  
  	/**
***************
*** 103,111 ****
  			'id'      => 'overview',
  			'title'   => __('Overview'),
  			'content' =>
! 				'<p>' . __( 'You can set a custom image header for your site. Simply upload the image and crop it, and the new header will go live immediately.' ) . '</p>' .
! 				'<p>' . __( 'If you want to discard your custom header and go back to the default included in your theme, click on the buttons to remove the custom image and restore the original header image.' ) . '</p>' .
! 				'<p>' . __( 'Some themes come with additional header images bundled. If you see multiple images displayed, select the one you&#8217;d like and click the Save Changes button.' ) . '</p>'
  		) );
  
  		get_current_screen()->set_help_sidebar(
--- 111,137 ----
  			'id'      => 'overview',
  			'title'   => __('Overview'),
  			'content' =>
! 				'<p>' . __( 'This screen is used to customize the header section of your theme.') . '</p>' .
! 				'<p>' . __( 'You can choose from the theme&#8217;s default header images, or use one of your own. You can also customize how your Site Title and Tagline are displayed.') . '<p>'
! 		) );
! 
! 		get_current_screen()->add_help_tab( array(
! 			'id'      => 'set-header-image',
! 			'title'   => __('Header Image'),
! 			'content' =>
! 				'<p>' . __( 'You can set a custom image header for your site. Simply upload the image and crop it, and the new header will go live immediately. Alternatively, you can use an image that has already been uploaded to your Media Library by clicking the &#8220;Choose Image&#8221; button.' ) . '</p>' .
! 				'<p>' . __( 'Some themes come with additional header images bundled. If you see multiple images displayed, select the one you&#8217;d like and click the &#8220;Save Changes&#8221; button.' ) . '</p>' .
! 				'<p>' . __( 'If your theme has more than one default header image, or you have uploaded more than one custom header image, you have the option of having WordPress display a randomly different image on each page of your site. Click the &#8220;Random&#8221; radio button next to the Uploaded Images or Default Images section to enable this feature.') . '</p>' .
! 				'<p>' . __( 'If you don&#8217;t want a header image to be displayed on your site at all, click the &#8220;Remove Header Image&#8221; button at the bottom of the Header Image section of this page. If you want to re-enable the header image later, you just have to select one of the other image options and click &#8220;Save Changes&#8221;.') . '</p>'
! 		) );
! 
! 		get_current_screen()->add_help_tab( array(
! 			'id'      => 'set-header-text',
! 			'title'   => __('Header Text'),
! 			'content' =>
! 				'<p>' . sprintf( __( 'For most themes, the header text is your Site Title and Tagline, as defined in the <a href="%1$s">General Settings</a> section.' ), admin_url( 'options-general.php' ) ) . '<p>' .
! 				'<p>' . __( 'In the Header Text section of this page, you can choose whether to display this text or hide it. You can also choose a color for the text by typing in a legitimate HTML hex value (eg: &#8220;#ff0000&#8221; for red) or by clicking &#8220;Select a Color&#8221; and dialing in a color using the color picker.') . '</p>' .
! 				'<p>' . __( 'Don&#8217;t forget to Save Changes when you&#8217;re done!') . '</p>'
  		) );
  
  		get_current_screen()->set_help_sidebar(
***************
*** 127,134 ****
  			return 1;
  
  		$step = (int) $_GET['step'];
! 		if ( $step < 1 || 3 < $step )
! 			$step = 1;
  
  		return $step;
  	}
--- 153,163 ----
  			return 1;
  
  		$step = (int) $_GET['step'];
! 		if ( $step < 1 || 3 < $step ||
! 			( 2 == $step && ! wp_verify_nonce( $_REQUEST['_wpnonce-custom-header-upload'], 'custom-header-upload' ) ) ||
! 			( 3 == $step && ! wp_verify_nonce( $_REQUEST['_wpnonce'], 'custom-header-crop-image' ) )
! 		)
! 			return 1;
  
  		return $step;
  	}
***************
*** 141,150 ****
  	function js_includes() {
  		$step = $this->step();
  
! 		if ( ( 1 == $step || 3 == $step ) && $this->header_text() )
! 			wp_enqueue_script('farbtastic');
! 		elseif ( 2 == $step )
  			wp_enqueue_script('imgareaselect');
  	}
  
  	/**
--- 170,184 ----
  	function js_includes() {
  		$step = $this->step();
  
! 		if ( ( 1 == $step || 3 == $step ) ) {
! 			add_thickbox();
! 			wp_enqueue_script( 'media-upload' );
! 			wp_enqueue_script( 'custom-header' );
! 			if ( current_theme_supports( 'custom-header', 'header-text' ) )
! 				wp_enqueue_script('farbtastic');
! 		} elseif ( 2 == $step ) {
  			wp_enqueue_script('imgareaselect');
+ 		}
  	}
  
  	/**
***************
*** 155,179 ****
  	function css_includes() {
  		$step = $this->step();
  
! 		if ( ( 1 == $step || 3 == $step ) && $this->header_text() )
  			wp_enqueue_style('farbtastic');
  		elseif ( 2 == $step )
  			wp_enqueue_style('imgareaselect');
  	}
  
  	/**
- 	 * Check if header text is allowed
- 	 *
- 	 * @since 3.0.0
- 	 */
- 	function header_text() {
- 		if ( defined( 'NO_HEADER_TEXT' ) && NO_HEADER_TEXT )
- 			return false;
- 
- 		return true;
- 	}
- 
- 	/**
  	 * Execute custom header modification.
  	 *
  	 * @since 2.6.0
--- 189,201 ----
  	function css_includes() {
  		$step = $this->step();
  
! 		if ( ( 1 == $step || 3 == $step ) && current_theme_supports( 'custom-header', 'header-text' ) )
  			wp_enqueue_style('farbtastic');
  		elseif ( 2 == $step )
  			wp_enqueue_style('imgareaselect');
  	}
  
  	/**
  	 * Execute custom header modification.
  	 *
  	 * @since 2.6.0
***************
*** 189,195 ****
  
  		if ( isset( $_POST['resetheader'] ) ) {
  			check_admin_referer( 'custom-header-options', '_wpnonce-custom-header-options' );
! 			remove_theme_mod( 'header_image' );
  			return;
  		}
  
--- 211,217 ----
  
  		if ( isset( $_POST['resetheader'] ) ) {
  			check_admin_referer( 'custom-header-options', '_wpnonce-custom-header-options' );
! 			$this->reset_header_image();
  			return;
  		}
  
***************
*** 201,236 ****
  
  		if ( isset( $_POST['removeheader'] ) ) {
  			check_admin_referer( 'custom-header-options', '_wpnonce-custom-header-options' );
! 			set_theme_mod( 'header_image', 'remove-header' );
  			return;
  		}
  
! 		if ( isset( $_POST['text-color'] ) ) {
  			check_admin_referer( 'custom-header-options', '_wpnonce-custom-header-options' );
  			$_POST['text-color'] = str_replace( '#', '', $_POST['text-color'] );
! 			if ( 'blank' == $_POST['text-color'] ) {
  				set_theme_mod( 'header_textcolor', 'blank' );
- 			} else {
- 				$color = preg_replace('/[^0-9a-fA-F]/', '', $_POST['text-color']);
- 				if ( strlen($color) == 6 || strlen($color) == 3 )
- 					set_theme_mod('header_textcolor', $color);
- 			}
  		}
  
  		if ( isset( $_POST['default-header'] ) ) {
  			check_admin_referer( 'custom-header-options', '_wpnonce-custom-header-options' );
! 			if ( 'random-default-image' == $_POST['default-header'] ) {
! 				set_theme_mod( 'header_image', 'random-default-image' );
! 			} elseif ( 'random-uploaded-image' == $_POST['default-header'] ) {
! 				set_theme_mod( 'header_image', 'random-uploaded-image' );
! 			} else {
! 				$this->process_default_headers();
! 				$uploaded = get_uploaded_header_images();
! 				if ( isset( $uploaded[$_POST['default-header']] ) )
! 					set_theme_mod( 'header_image', esc_url( $uploaded[$_POST['default-header']]['url'] ) );
! 				elseif ( isset( $this->default_headers[$_POST['default-header']] ) )
! 					set_theme_mod( 'header_image', esc_url( $this->default_headers[$_POST['default-header']]['url'] ) );
! 			}
  		}
  	}
  
--- 223,249 ----
  
  		if ( isset( $_POST['removeheader'] ) ) {
  			check_admin_referer( 'custom-header-options', '_wpnonce-custom-header-options' );
! 			$this->remove_header_image();
  			return;
  		}
  
! 		if ( isset( $_POST['text-color'] ) && ! isset( $_POST['display-header-text'] ) ) {
! 			check_admin_referer( 'custom-header-options', '_wpnonce-custom-header-options' );
! 			set_theme_mod( 'header_textcolor', 'blank' );
! 		} elseif ( isset( $_POST['text-color'] ) ) {
  			check_admin_referer( 'custom-header-options', '_wpnonce-custom-header-options' );
  			$_POST['text-color'] = str_replace( '#', '', $_POST['text-color'] );
! 			$color = preg_replace('/[^0-9a-fA-F]/', '', $_POST['text-color']);
! 			if ( strlen($color) == 6 || strlen($color) == 3 )
! 				set_theme_mod('header_textcolor', $color);
! 			elseif ( ! $color )
  				set_theme_mod( 'header_textcolor', 'blank' );
  		}
  
  		if ( isset( $_POST['default-header'] ) ) {
  			check_admin_referer( 'custom-header-options', '_wpnonce-custom-header-options' );
! 			$this->set_header_image( $_POST['default-header'] );
! 			return;
  		}
  	}
  
***************
*** 290,298 ****
  			echo '<div class="default-header">';
  			echo '<label><input name="default-header" type="radio" value="' . esc_attr( $header_key ) . '" ' . checked( $header_url, get_theme_mod( 'header_image' ), false ) . ' />';
  			$width = '';
! 			if ( !empty( $header['uploaded'] ) )
  				$width = ' width="230"';
! 			echo '<img src="' . $header_thumbnail . '" alt="' . esc_attr( $header_desc ) .'" title="' . esc_attr( $header_desc ) . '"' . $width . ' /></label>';
  			echo '</div>';
  		}
  		echo '<div class="clear"></div></div>';
--- 303,311 ----
  			echo '<div class="default-header">';
  			echo '<label><input name="default-header" type="radio" value="' . esc_attr( $header_key ) . '" ' . checked( $header_url, get_theme_mod( 'header_image' ), false ) . ' />';
  			$width = '';
! 			if ( !empty( $header['attachment_id'] ) )
  				$width = ' width="230"';
! 			echo '<img src="' . set_url_scheme( $header_thumbnail ) . '" alt="' . esc_attr( $header_desc ) .'" title="' . esc_attr( $header_desc ) . '"' . $width . ' /></label>';
  			echo '</div>';
  		}
  		echo '<div class="clear"></div></div>';
***************
*** 305,311 ****
  	 */
  	function js() {
  		$step = $this->step();
! 		if ( ( 1 == $step || 3 == $step ) && $this->header_text() )
  			$this->js_1();
  		elseif ( 2 == $step )
  			$this->js_2();
--- 318,324 ----
  	 */
  	function js() {
  		$step = $this->step();
! 		if ( ( 1 == $step || 3 == $step ) && current_theme_supports( 'custom-header', 'header-text' ) )
  			$this->js_1();
  		elseif ( 2 == $step )
  			$this->js_2();
***************
*** 319,404 ****
  	function js_1() { ?>
  <script type="text/javascript">
  /* <![CDATA[ */
! 	var text_objects = ['#name', '#desc', '#text-color-row'];
! 	var farbtastic;
! 	var default_color = '#<?php echo HEADER_TEXTCOLOR; ?>';
! 	var old_color = null;
  
  	function pickColor(color) {
! 		jQuery('#name').css('color', color);
! 		jQuery('#desc').css('color', color);
! 		jQuery('#text-color').val(color);
  		farbtastic.setColor(color);
  	}
  
! 	function toggle_text(s) {
! 		if (jQuery(s).attr('id') == 'showtext' && jQuery('#text-color').val() != 'blank')
  			return;
! 
! 		if (jQuery(s).attr('id') == 'hidetext' && jQuery('#text-color').val() == 'blank')
! 			return;
! 
! 		if (jQuery('#text-color').val() == 'blank') {
! 			//Show text
! 			if (old_color == '#blank')
! 				old_color = default_color;
! 
! 			jQuery( text_objects.toString() ).show();
! 			jQuery('#text-color').val(old_color);
! 			jQuery('#name').css('color', old_color);
! 			jQuery('#desc').css('color', old_color);
! 			pickColor(old_color);
  		} else {
! 			//Hide text
! 			jQuery( text_objects.toString() ).hide();
! 			old_color = jQuery('#text-color').val();
! 			jQuery('#text-color').val('blank');
  		}
  	}
  
! 	jQuery(document).ready(function() {
! 		jQuery('#pickcolor').click(function() {
! 			jQuery('#color-picker').show();
  		});
  
! 		jQuery('input[name="hidetext"]').click(function() {
! 			toggle_text(this);
! 		});
  
! 		jQuery('#defaultcolor').click(function() {
  			pickColor(default_color);
! 			jQuery('#text-color').val(default_color)
  		});
  
! 		jQuery('#text-color').keyup(function() {
! 			var _hex = jQuery('#text-color').val();
  			var hex = _hex;
  			if ( hex[0] != '#' )
  				hex = '#' + hex;
  			hex = hex.replace(/[^#a-fA-F0-9]+/, '');
  			if ( hex != _hex )
! 				jQuery('#text-color').val(hex);
  			if ( hex.length == 4 || hex.length == 7 )
  				pickColor( hex );
  		});
  
! 		jQuery(document).mousedown(function(){
! 			jQuery('#color-picker').each( function() {
! 				var display = jQuery(this).css('display');
  				if (display == 'block')
! 					jQuery(this).fadeOut(2);
  			});
  		});
  
! 		farbtastic = jQuery.farbtastic('#color-picker', function(color) { pickColor(color); });
! 		<?php if ( $color = get_theme_mod('header_textcolor', HEADER_TEXTCOLOR) ) { ?>
! 		pickColor('#<?php echo $color; ?>');
! 		<?php } ?>
! 
! 		<?php if ( 'blank' == get_theme_mod( 'header_textcolor', HEADER_TEXTCOLOR ) || '' == get_theme_mod('header_textcolor', HEADER_TEXTCOLOR) || ! $this->header_text() ) { ?>
  		toggle_text();
  		<?php } ?>
  	});
  /* ]]> */
  </script>
  <?php
--- 332,406 ----
  	function js_1() { ?>
  <script type="text/javascript">
  /* <![CDATA[ */
! var farbtastic;
! (function($){
! 	var default_color = '#<?php echo get_theme_support( 'custom-header', 'default-text-color' ); ?>',
! 		header_text_fields;
  
  	function pickColor(color) {
! 		$('#name').css('color', color);
! 		$('#desc').css('color', color);
! 		$('#text-color').val(color);
  		farbtastic.setColor(color);
  	}
  
! 	function toggle_text() {
! 		var checked = $('#display-header-text').prop('checked'),
! 			text_color;
! 		header_text_fields.toggle( checked );
! 		if ( ! checked )
  			return;
! 		text_color = $('#text-color');
! 		if ( '' == text_color.val().replace('#', '') ) {
! 			text_color.val( default_color );
! 			pickColor( default_color );
  		} else {
! 			pickColor( text_color.val() );
  		}
  	}
  
! 	$(document).ready(function() {
! 		header_text_fields = $('.displaying-header-text');
! 		$('#pickcolor').click(function(e) {
! 			e.preventDefault();
! 			$('#color-picker').show();
  		});
  
! 		$('#display-header-text').click( toggle_text );
  
! 		$('#defaultcolor').click(function() {
  			pickColor(default_color);
! 			$('#text-color').val(default_color);
  		});
  
! 		$('#text-color').keyup(function() {
! 			var _hex = $('#text-color').val();
  			var hex = _hex;
  			if ( hex[0] != '#' )
  				hex = '#' + hex;
  			hex = hex.replace(/[^#a-fA-F0-9]+/, '');
  			if ( hex != _hex )
! 				$('#text-color').val(hex);
  			if ( hex.length == 4 || hex.length == 7 )
  				pickColor( hex );
  		});
  
! 		$(document).mousedown(function(){
! 			$('#color-picker').each( function() {
! 				var display = $(this).css('display');
  				if (display == 'block')
! 					$(this).fadeOut(2);
  			});
  		});
  
! 		farbtastic = $.farbtastic('#color-picker', function(color) { pickColor(color); });
! 		<?php if ( display_header_text() ) { ?>
! 		pickColor('#<?php echo get_header_textcolor(); ?>');
! 		<?php } else { ?>
  		toggle_text();
  		<?php } ?>
  	});
+ })(jQuery);
  /* ]]> */
  </script>
  <?php
***************
*** 420,427 ****
  	}
  
  	jQuery(document).ready(function() {
! 		var xinit = <?php echo HEADER_IMAGE_WIDTH; ?>;
! 		var yinit = <?php echo HEADER_IMAGE_HEIGHT; ?>;
  		var ratio = xinit / yinit;
  		var ximg = jQuery('img#upload').width();
  		var yimg = jQuery('img#upload').height();
--- 422,429 ----
  	}
  
  	jQuery(document).ready(function() {
! 		var xinit = <?php echo absint( get_theme_support( 'custom-header', 'width' ) ); ?>;
! 		var yinit = <?php echo absint( get_theme_support( 'custom-header', 'height' ) ); ?>;
  		var ratio = xinit / yinit;
  		var ximg = jQuery('img#upload').width();
  		var yimg = jQuery('img#upload').height();
***************
*** 439,452 ****
  		jQuery('img#upload').imgAreaSelect({
  			handles: true,
  			keys: true,
- 			aspectRatio: xinit + ':' + yinit,
  			show: true,
  			x1: 0,
  			y1: 0,
  			x2: xinit,
  			y2: yinit,
! 			maxHeight: <?php echo HEADER_IMAGE_HEIGHT; ?>,
! 			maxWidth: <?php echo HEADER_IMAGE_WIDTH; ?>,
  			onInit: function () {
  				jQuery('#width').val(xinit);
  				jQuery('#height').val(yinit);
--- 441,468 ----
  		jQuery('img#upload').imgAreaSelect({
  			handles: true,
  			keys: true,
  			show: true,
  			x1: 0,
  			y1: 0,
  			x2: xinit,
  			y2: yinit,
! 			<?php
! 			if ( ! current_theme_supports( 'custom-header', 'flex-height' ) && ! current_theme_supports( 'custom-header', 'flex-width' ) ) {
! 			?>
! 			aspectRatio: xinit + ':' + yinit,
! 			<?php
! 			}
! 			if ( ! current_theme_supports( 'custom-header', 'flex-height' ) ) {
! 			?>
! 			maxHeight: <?php echo get_theme_support( 'custom-header', 'height' ); ?>,
! 			<?php
! 			}
! 			if ( ! current_theme_supports( 'custom-header', 'flex-width' ) ) {
! 			?>
! 			maxWidth: <?php echo get_theme_support( 'custom-header', 'width' ); ?>,
! 			<?php
! 			}
! 			?>
  			onInit: function () {
  				jQuery('#width').val(xinit);
  				jQuery('#height').val(yinit);
***************
*** 483,488 ****
--- 499,506 ----
  </div>
  <?php } ?>
  
+ <h3><?php _e( 'Header Image' ); ?></h3>
+ 
  <table class="form-table">
  <tbody>
  
***************
*** 486,526 ****
  <table class="form-table">
  <tbody>
  
- 
  <tr valign="top">
  <th scope="row"><?php _e( 'Preview' ); ?></th>
! <td >
  	<?php if ( $this->admin_image_div_callback ) {
  	  call_user_func( $this->admin_image_div_callback );
  	} else {
  	?>
! 	<div id="headimg" style="max-width:<?php echo HEADER_IMAGE_WIDTH; ?>px;height:<?php echo HEADER_IMAGE_HEIGHT; ?>px;background-image:url(<?php esc_url ( header_image() ) ?>);">
  		<?php
! 		if ( 'blank' == get_theme_mod('header_textcolor', HEADER_TEXTCOLOR) || '' == get_theme_mod('header_textcolor', HEADER_TEXTCOLOR) || ! $this->header_text() )
! 			$style = ' style="display:none;"';
  		else
! 			$style = ' style="color:#' . get_theme_mod( 'header_textcolor', HEADER_TEXTCOLOR ) . ';"';
  		?>
! 		<h1><a id="name"<?php echo $style; ?> onclick="return false;" href="<?php bloginfo('url'); ?>"><?php bloginfo( 'name' ); ?></a></h1>
! 		<div id="desc"<?php echo $style; ?>><?php bloginfo( 'description' ); ?></div>
  	</div>
  	<?php } ?>
  </td>
  </tr>
! <?php if ( current_theme_supports( 'custom-header-uploads' ) ) : ?>
  <tr valign="top">
! <th scope="row"><?php _e( 'Upload Image' ); ?></th>
  <td>
  	<p><?php _e( 'You can upload a custom header image to be shown at the top of your site instead of the default one. On the next screen you will be able to crop the image.' ); ?><br />
! 	<?php printf( __( 'Images of exactly <strong>%1$d &times; %2$d pixels</strong> will be used as-is.' ), HEADER_IMAGE_WIDTH, HEADER_IMAGE_HEIGHT ); ?></p>
  	<form enctype="multipart/form-data" id="upload-form" method="post" action="<?php echo esc_attr( add_query_arg( 'step', 2 ) ) ?>">
  	<p>
  		<label for="upload"><?php _e( 'Choose an image from your computer:' ); ?></label><br />
  		<input type="file" id="upload" name="import" />
  		<input type="hidden" name="action" value="save" />
! 		<?php wp_nonce_field( 'custom-header-upload', '_wpnonce-custom-header-upload' ) ?>
  		<?php submit_button( __( 'Upload' ), 'button', 'submit', false ); ?>
  	</p>
  	</form>
  </td>
  </tr>
--- 504,568 ----
  <table class="form-table">
  <tbody>
  
  <tr valign="top">
  <th scope="row"><?php _e( 'Preview' ); ?></th>
! <td>
  	<?php if ( $this->admin_image_div_callback ) {
  	  call_user_func( $this->admin_image_div_callback );
  	} else {
  	?>
! 	<div id="headimg" style="background-image:url(<?php esc_url ( header_image() ) ?>);max-width:<?php echo get_custom_header()->width; ?>px;height:<?php echo get_custom_header()->height; ?>px;">
  		<?php
! 		if ( display_header_text() )
! 			$style = ' style="color:#' . get_header_textcolor() . ';"';
  		else
! 			$style = ' style="display:none;"';
  		?>
! 		<h1><a id="name" class="displaying-header-text" <?php echo $style; ?> onclick="return false;" href="<?php bloginfo('url'); ?>"><?php bloginfo( 'name' ); ?></a></h1>
! 		<div id="desc" class="displaying-header-text" <?php echo $style; ?>><?php bloginfo( 'description' ); ?></div>
  	</div>
  	<?php } ?>
  </td>
  </tr>
! <?php if ( current_theme_supports( 'custom-header', 'uploads' ) ) : ?>
  <tr valign="top">
! <th scope="row"><?php _e( 'Select Image' ); ?></th>
  <td>
  	<p><?php _e( 'You can upload a custom header image to be shown at the top of your site instead of the default one. On the next screen you will be able to crop the image.' ); ?><br />
! 	<?php
! 	if ( ! current_theme_supports( 'custom-header', 'flex-height' ) && ! current_theme_supports( 'custom-header', 'flex-width' ) ) {
! 		printf( __( 'Images of exactly <strong>%1$d &times; %2$d pixels</strong> will be used as-is.' ) . '<br />', get_theme_support( 'custom-header', 'width' ), get_theme_support( 'custom-header', 'height' ) );
! 	} elseif ( current_theme_supports( 'custom-header', 'flex-height' ) ) {
! 		if ( ! current_theme_supports( 'custom-header', 'flex-width' ) )
! 			printf( __( 'Images should be at least <strong>%1$d pixels</strong> wide.' ) . ' ', get_theme_support( 'custom-header', 'width' ) );
! 	} elseif ( current_theme_supports( 'custom-header', 'flex-width' ) ) {
! 		if ( ! current_theme_supports( 'custom-header', 'flex-height' ) )
! 			printf( __( 'Images should be at least <strong>%1$d pixels</strong> tall.' ) . ' ', get_theme_support( 'custom-header', 'height' ) );
! 	}
! 	if ( current_theme_supports( 'custom-header', 'flex-height' ) || current_theme_supports( 'custom-header', 'flex-width' ) ) {
! 		if ( current_theme_supports( 'custom-header', 'width' ) )
! 			printf( __( 'Suggested width is <strong>%1$d pixels</strong>.' ) . ' ', get_theme_support( 'custom-header', 'width' ) );
! 		if ( current_theme_supports( 'custom-header', 'height' ) )
! 			printf( __( 'Suggested height is <strong>%1$d pixels</strong>.' ) . ' ', get_theme_support( 'custom-header', 'height' ) );
! 	}
! 	?></p>
  	<form enctype="multipart/form-data" id="upload-form" method="post" action="<?php echo esc_attr( add_query_arg( 'step', 2 ) ) ?>">
  	<p>
  		<label for="upload"><?php _e( 'Choose an image from your computer:' ); ?></label><br />
  		<input type="file" id="upload" name="import" />
  		<input type="hidden" name="action" value="save" />
! 		<?php wp_nonce_field( 'custom-header-upload', '_wpnonce-custom-header-upload' ); ?>
  		<?php submit_button( __( 'Upload' ), 'button', 'submit', false ); ?>
  	</p>
+ 	<?php
+ 		$image_library_url = get_upload_iframe_src( 'image', null, 'library' );
+ 		$image_library_url = remove_query_arg( 'TB_iframe', $image_library_url );
+ 		$image_library_url = add_query_arg( array( 'context' => 'custom-header', 'TB_iframe' => 1 ), $image_library_url );
+ 	?>
+ 	<p>
+ 		<label for="choose-from-library-link"><?php _e( 'Or choose an image from your media library:' ); ?></label><br />
+ 		<a id="choose-from-library-link" class="button thickbox" href="<?php echo esc_url( $image_library_url ); ?>"><?php _e( 'Choose Image' ); ?></a>
+ 	</p>
  	</form>
  </td>
  </tr>
***************
*** 546,552 ****
  <tr valign="top">
  <th scope="row"><?php _e( 'Default Images' ); ?></th>
  <td>
! <?php if ( current_theme_supports( 'custom-header-uploads' ) ) : ?>
  	<p><?php _e( 'If you don&lsquo;t want to upload your own image, you can use one of these cool headers, or show a random one.' ) ?></p>
  <?php else: ?>
  	<p><?php _e( 'You can use one of these cool headers or show a random one on each page.' ) ?></p>
--- 588,594 ----
  <tr valign="top">
  <th scope="row"><?php _e( 'Default Images' ); ?></th>
  <td>
! <?php if ( current_theme_supports( 'custom-header', 'uploads' ) ) : ?>
  	<p><?php _e( 'If you don&lsquo;t want to upload your own image, you can use one of these cool headers, or show a random one.' ) ?></p>
  <?php else: ?>
  	<p><?php _e( 'You can use one of these cool headers or show a random one on each page.' ) ?></p>
***************
*** 567,573 ****
  </tr>
  	<?php endif;
  
! 	if ( defined( 'HEADER_IMAGE' ) && '' != HEADER_IMAGE ) : ?>
  <tr valign="top">
  <th scope="row"><?php _e( 'Reset Image' ); ?></th>
  <td>
--- 609,616 ----
  </tr>
  	<?php endif;
  
! 	$default_image = get_theme_support( 'custom-header', 'default-image' );
! 	if ( $default_image && get_header_image() != $default_image ) : ?>
  <tr valign="top">
  <th scope="row"><?php _e( 'Reset Image' ); ?></th>
  <td>
***************
*** 579,611 ****
  </tbody>
  </table>
  
! 	<?php if ( $this->header_text() ) : ?>
  <table class="form-table">
  <tbody>
! <tr valign="top" class="hide-if-no-js">
! <th scope="row"><?php _e( 'Display Text' ); ?></th>
  <td>
  	<p>
! 	<?php $hidetext = get_theme_mod( 'header_textcolor', HEADER_TEXTCOLOR ); ?>
! 	<label><input type="radio" value="1" name="hidetext" id="hidetext"<?php checked( ( 'blank' == $hidetext || empty( $hidetext ) )  ? true : false ); ?> /> <?php _e( 'No' ); ?></label>
! 	<label><input type="radio" value="0" name="hidetext" id="showtext"<?php checked( ( 'blank' == $hidetext || empty( $hidetext ) ) ? false : true ); ?> /> <?php _e( 'Yes' ); ?></label>
  	</p>
  </td>
  </tr>
  
! <tr valign="top" id="text-color-row">
  <th scope="row"><?php _e( 'Text Color' ); ?></th>
  <td>
  	<p>
! 		<input type="text" name="text-color" id="text-color" value="#<?php echo esc_attr( get_theme_mod( 'header_textcolor', HEADER_TEXTCOLOR ) ); ?>" />
! 		<span class="description hide-if-js"><?php _e( 'If you want to hide header text, add <strong>#blank</strong> as text color.' );?></span>
! 		<input type="button" class="button hide-if-no-js" value="<?php esc_attr_e( 'Select a Color' ); ?>" id="pickcolor" />
  	</p>
  	<div id="color-picker" style="z-index: 100; background:#eee; border:1px solid #ccc; position:absolute; display:none;"></div>
  </td>
  </tr>
  
! 	<?php if ( defined('HEADER_TEXTCOLOR') && get_theme_mod('header_textcolor') ) { ?>
  <tr valign="top">
  <th scope="row"><?php _e('Reset Text Color'); ?></th>
  <td>
--- 622,658 ----
  </tbody>
  </table>
  
! <?php if ( current_theme_supports( 'custom-header', 'header-text' ) ) : ?>
! 
! <h3><?php _e( 'Header Text' ); ?></h3>
! 
  <table class="form-table">
  <tbody>
! <tr valign="top">
! <th scope="row"><?php _e( 'Header Text' ); ?></th>
  <td>
  	<p>
! 	<label><input type="checkbox" name="display-header-text" id="display-header-text"<?php checked( display_header_text() ); ?> /> <?php _e( 'Show header text with your image.' ); ?></label>
  	</p>
  </td>
  </tr>
  
! <tr valign="top" class="displaying-header-text">
  <th scope="row"><?php _e( 'Text Color' ); ?></th>
  <td>
  	<p>
! <?php if ( display_header_text() ) : ?>
! 		<input type="text" name="text-color" id="text-color" value="#<?php echo esc_attr( get_header_textcolor() ); ?>" />
! <?php else : ?>
! 		<input type="text" name="text-color" id="text-color" value="#<?php echo esc_attr( get_theme_support( 'custom-header', 'default-text-color' ) ); ?>" />
! <?php endif; ?>
! 		<a href="#" class="hide-if-no-js" id="pickcolor"><?php _e( 'Select a Color' ); ?></a>
  	</p>
  	<div id="color-picker" style="z-index: 100; background:#eee; border:1px solid #ccc; position:absolute; display:none;"></div>
  </td>
  </tr>
  
! 	<?php if ( current_theme_supports( 'custom-header', 'default-text-color' ) && get_theme_mod( 'header_textcolor' ) ) { ?>
  <tr valign="top">
  <th scope="row"><?php _e('Reset Text Color'); ?></th>
  <td>
***************
*** 617,623 ****
  
  </tbody>
  </table>
! 	<?php endif;
  
  do_action( 'custom_header_options' );
  
--- 664,670 ----
  
  </tbody>
  </table>
! <?php endif;
  
  do_action( 'custom_header_options' );
  
